/*
 *	Copyright: Torquil Gault (tag@scatha.apana.org.au), 1998+
 *
 */

import javax.swing.*;
import java.awt.event.*;
import java.util.*;

public class KeySearch {
	public JTextField searchField;
	public JList searchResults;
	public String[] searchData;
	public String[] searchDataClone;
	public Vector resultData;
	public String searchText;

	public int cnt;

	public KeySearch(JTextField _Field, JList _Results, String[] _Data) {
		this.searchField = _Field;
		this.searchResults = _Results;
		this.searchData = _Data;
		this.searchDataClone = new String[searchData.length];
		for (cnt=0; cnt < searchData.length; cnt++) {
		   searchDataClone[cnt] = new String(searchData[cnt].toLowerCase());
		}

		resultData = new Vector();
		searchResults.setListData(searchData);

		searchField.addKeyListener(new KeyAdapter() {
			public void keyReleased(KeyEvent e) {
				searchText = searchField.getText().toLowerCase();
				if (searchText.length() == 0) {
				    searchResults.setListData(searchData);
				}
				else {
				    resultData.removeAllElements();
		    		    for (cnt=0; cnt < searchData.length; cnt++) {
		    			if (searchDataClone[cnt].startsWith(searchText))
		    			    resultData.add(searchData[cnt]);
		    		    }
		    		    searchResults.setListData(resultData);
				}
			}
		});
	}
}
